(define-module (ui drweb selected ajax)
    :use-module (alterator woo)
    :use-module (alterator ajax)
  :export (init))

(define *parameters* '("q_file" "q_date" "q_from" "q_to" "q_subj" "q_reason"))

(define (return) (form-replace "/drweb/quarantine"))

(define (read_file)
     (form-update-value-list *parameters*
         (woo-read-first "/drweb/file" 
             'file (form-value "file_select") 
             'language (form-value "language")))
)

(define (delete_file)
    (woo-delete "/drweb/file" 
	    'file (form-value "file_select") 
	    'language (form-value "language"))
    (init_fileselector)
    (read_file)
)

(define (scan_file)
    (catch/message
	(lambda()
    	    (woo-write "/drweb/scan"
    		'file (form-value "file_select") 
                'language (form-value "language"))
    ))
)

(define (rel_and_send)
    (woo-write "/drweb/deliver_file" 'file (form-value "file_select") )
    (init_fileselector)
    (read_file)
)

(define (init_fileselector)
(let* ((data (woo-list "/drweb/flist"))
	 (cur_name (and (pair? data) (woo-get-option (car data) 'name))))
    (form-update-enum "file_select" data) 
    (and cur_name (form-update-value "file_select" cur_name) ))

)

(define (ui-init) 
    (init_fileselector)
    (let ((selected (form-value "name")))
	(form-update-value "file_select" selected)
	(read_file))
)

(define (init)
    (ui-init)
    (form-bind "return_btn" "click" return)
    (form-bind "delete_selected_btn" "click" delete_file)
    (form-bind "release_selected_btn" "click" rel_and_send)
    (form-bind "rescan_selected_btn" "click" scan_file)
    (form-bind "file_select" "change" read_file)
    
)
